add_printer("/account.php", function()
	pwd = get_session_state("pwd")
	table = [[
	<table  width=95%%  cellspacing=0 cellpadding=0>
		<tr><td style="color: white;" align=center bgcolor=blue><b>Kolproxy Options</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid blue;">
			<center><table><tr><td>
				<p><a href="custom-settings?pwd=]] .. pwd .. [[">Go to kolproxy settings</a></p>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	]]
	text = string.gsub(text, [[<span id="ro">]], "\n" .. table .. "%0")
end)

function make_buttons(valuestr, value, options)
	buttons = ""
	for _, v in pairs(options) do
		if value == v.value then
			buttons = buttons .. [[<input type="radio" name="]]..valuestr..[[" value="]] .. v.value .. [[" checked="yes">]] .. v.text
		else
			buttons = buttons .. [[<input type="radio" name="]]..valuestr..[[" value="]] .. v.value .. [[">]] .. v.text
		end
	end
	return buttons
end

add_printer("/custom-settings", function()
	pwd = get_session_state("pwd") -- Inserting pwd, boo!
	settings = {
-- 		{ title = "Automate choice noncombats", set = "character", name = "automate choice noncombats", field = "yesno" },
		{ title = "Allow the kolproxy Lua scripts to download pages", set = "character", name = "run automation scripts", field = "yesno", default_yes = true, explanation = "Required for other advanced functionality to work.<br><br>If this is disabled, then only the pages your browser specifically requests will be downloaded from the server. E.g. if you were to click the ascension checklist, it would try to download it from the KoL server and return an error message, instead of letting the script run and load your inventory/storage/closet.<br><br>You probably always want this enabled. If it's disabled, kolproxy scripts are limited to only parsing/changing page text." },
		{ title = "Automatically complete click-click-click tasks and puzzles that don't cost turns", set = "character", name = "automate simple tasks", field = "yesno", explanation = "This enables the things kolproxy can do behind the scenes, such as using the plus sign when you get it, solving the strange leaflet when you use it, using evil eyes, etc.<br><br>You probably want this enabled unless there are bugs in the automation code, which could damage your run." },
		{ title = "Also use experimental implementations (could contain bugs)", set = "character", name = "enable experimental implementations", field = "yesno", explanation = "Current experimental implementations:<br><ul><li>Mining solver</li><li>Hedge maze puzzle solver</li></ul>" },
		{ title = "Enable warnings about semirares, not enough meat, etc.", set = "character", name = "enable adventure warnings", field = "yesno" },
		{ title = "Automate daily visits (rumpus room, garden, etc.)", set = "character", name = "automate daily visits", field = "yesno" },
		{ title = "Enable automatic turn playing functionality (stupid and wrong, but convenient)", set = "character", name = "enable turn automation", field = "yesno" },
		{ title = "Ask chatbot for bounty/clover status on logon", set = "character", name = "ask chatbot on logon", field = "yesno" },
-- 		{ title = "Enable ascension automation", set = "character", name = "enable ascension automation", field = "yesno" },
-- 		{ title = "Aftercore logout outfit", set = "character", name = "logout outfit", field = "text", example = "Rollover" },
-- 		{ title = "Healing skill ID", set = "ascension", name = "healing skill", field = "number", example = "3012" },
-- 		{ title = "Buffing outfit", set = "ascension", name = "buffing outfit", field = "text", example = "Buffing" },
-- 		{ title = "Buffing outfit (when auto-healing)", set = "ascension", name = "autoheal buffing outfit", field = "text", example = "Buffing" },
	}
	settingstext = ""
	for idx, s in pairs(settings) do
		value = get_state(s.set, s.name)
		namestr = "name-" .. tostring(idx)
		valuestr = "value-" .. tostring(idx)
		if s.field == "text" then
-- 			example = [[(e.g. <i>]] .. s.example .. [[</i>)]]
-- 			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]] .. example
-- 		elseif s.field == "number" then
-- 			example = [[(e.g. <i>]] .. s.example .. [[</i>)]]
-- 			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]] .. example
		elseif s.field == "yesno" then
			if value == "yes" then
				checkbox_value = [[checked="checked" ]]
			elseif value == "no" then
				checkbox_value = [[]]
			else
				if s.default_yes then
					checkbox_value = [[checked="checked" ]]
				else
					checkbox_value = [[]]
				end
			end
			explanationmark = ""
			explanationtext = ""
			if s.explanation then
				explanationmark = [[<sup><b><a class='nounder' href="javascript:toggle('explanation-]]..tostring(idx)..[[')">(?)</a></b></sup>]]
				explanationtext = [[
<div id='explanation-]]..tostring(idx)..[[' style="display: none"><div class="helpbox">]]..s.explanation..[[</div></div>]]
			end
			inputelem = [[<input type="checkbox" ]]..checkbox_value..[[name="]]..s.name..[[" onChange="click_cb(this, ']]..s.name..[[', ']]..s.set..[[')"/>]]
			checkbox = [[<div><label style="padding: 3px" for="]] .. s.name .. [[">]]..inputelem..s.title..[[</label>]]..explanationmark..[[</div>]]
			item_text = [[<div id="]] .. s.name .. [[" class="opt checkbox">]] .. checkbox .. [[<input type="hidden" class="stateset" value="]] .. s.set .. [[">]]..explanationtext..[[</div>]]
-- 		elseif s.field == "option" then
-- 			buttons = make_buttons(valuestr, value, s.values)
-- 			item_text = s.title .. [[ = ]] .. buttons
-- 		else
-- 			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]]
		end
		this_text = [[<p>
		<input type="hidden" name="]]..namestr..[[" value="]] .. s.name .. [[">
		]] .. item_text .. [[
		<input type="hidden" name="stateset-]]..idx..[[" value="]] .. s.set .. [[">
</p>
]]
		settingstext = settingstext .. this_text
	end
	text = [[
	<table  width=95%%  cellspacing=0 cellpadding=0>
		<tr><td style="color: white;" align=center bgcolor=blue><b>Kolproxy settings</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid blue;">
			<center><table><tr><td>
				<form action="custom-settings" method="post">
					]] .. settingstext .. [[
					<input type="hidden" name="pwd" value="]] .. pwd .. [["><input type="hidden" name="action" value="set state">
				</form>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	<table  width=95%%  cellspacing=0 cellpadding=0>
		<tr><td style="color: white;" align=center bgcolor=blue><b>Kolproxy special pages</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid blue;">
			<center><table><tr><td>
			<!-- <tr><td><center><a href="custom-logs">Parse logs (experimental)</a></center></td></tr> -->
			<tr><td><center><a href="custom-mix-drinks">Craftable advanced cocktails (experimental)</a></center></td></tr>
			<!-- <tr><td><center><a href="custom-ascension-checklist">Ascension checklist</a></center></td></tr> -->
			<tr><td><center><a href="http://www.houeland.com/kolproxy/wiki/" target="_blank">Open documentation in a new tab</a></center></td></tr>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	<table  width=95%%  cellspacing=0 cellpadding=0>
		<tr><td style="color: white;" align=center bgcolor=blue><b>Server settings</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid blue;">
			<center><table><tr><td>
				<form action="custom-store-settings" method="post">
					<input type="hidden" name="pwd" value="]] .. pwd .. [[">
					<input type="submit" value="Store kolproxy settings on server">
				</form>
				<form action="custom-load-settings" method="post">
					<input type="hidden" name="pwd" value="]] .. pwd .. [[">
					<input type="submit" value="Load kolproxy settings from server">
				</form>
			<tr><td><center><a href="account.php">Back to Account Menu</a></center></td></tr>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	]]
	text = [[
		<html>
		<head>
			<script language="Javascript" src="http://images.kingdomofloathing.com/scripts/core.js"></script>
			<link rel="stylesheet" type="text/css" href="http://images.kingdomofloathing.com/styles.css">
			<style type="text/css">
				label {
					font-weight: bold;
				}
				.helpbox {
				   width: 500px;
				   border: 1px solid black;
				   padding: 5px;
				}
			</style>
			<script language="Javascript" src="http://images.kingdomofloathing.com/scripts/jquery-1.3.1.min.js"></script>
			<script>
var pwd = "]]..pwd..[[";
function click_cb(cb, name, stateset) {
	var cur = "no"
	if (cb.checked) {
		cur = "yes"
	}
	$.post('custom-settings', { pwd:pwd, action:'set state', name:name, stateset:stateset, value:cur, ajax: 1 }, function (res) {
		enableDiv(label);
	});
	return true;
}
			</script>
		</head>
		<body>]] .. text .. [[
		</body>
		</html>]]
--~ 	print("params", params)
end)
